export type AIEnemyComponent = {
  leftForPatrol: boolean;
  targetCamp: string;
  targetBeingCaptured?: string;
  maxChaseDistance: number;
  maxCaptureDistance: number;
  capturingTime: number;
  undressingTime: number;
  remainingCaptureTime: number;
  remainingUndressingTime: number;
  captureStrength: number;
  struggleStrength: number;
  patrolMovementSpeed: number;
  chaseMovementSpeed: number;
};

export function createAIEnemyComponent(targetCamp: string): AIEnemyComponent {
  return {
    leftForPatrol: false,
    targetCamp,
    capturingTime: 50,
    undressingTime: 30,
    remainingCaptureTime: 0,
    remainingUndressingTime: 0,
    maxChaseDistance: 4,
    maxCaptureDistance: 2,
    captureStrength: 50,
    struggleStrength: 0.1,
    patrolMovementSpeed: 0.05,
    chaseMovementSpeed: 0.3,
  };
}
