export type AIGuardComponent = {
  targetTown: string;
  hasRetargetedNearestTown: boolean;
  targetBeingChased?: string;
  maxChaseDistance: number;
  maxCaptureDistance: number;
  capturingTime: number;
  remainingCaptureTime: number;
  captureStrength: number;
  struggleStrength: number;
  targetBeingFreed?: string;
  maxFreeDistance: number;
  patrolMovementSpeed: number;
  chaseMovementSpeed: number;
  escapeMovementSpeed: number;
};

export function createAIGuardComponent(targetTown: string): AIGuardComponent {
  return {
    targetTown,
    hasRetargetedNearestTown: false,
    capturingTime: 50,
    remainingCaptureTime: 0,
    maxChaseDistance: 4,
    maxCaptureDistance: 2,
    maxFreeDistance: 2,
    captureStrength: 50,
    struggleStrength: 0.1,
    patrolMovementSpeed: 0.08,
    chaseMovementSpeed: 0.2,
    escapeMovementSpeed: 0.2,
  };
}
