export type CapturableComponent = {
  isCapturableByTownie: boolean;
  isFreeableByTownie: boolean;
  isCapturableByBandits: boolean;
  isFreeableByBandits: boolean;
  state: "free" | "grabbed" | "bound";
  isStruggling: boolean;
  remainingTightness: number;
  totalTightness: number;
};

export function createCapturableComponent(options: {
  townieEnemy?: boolean;
  townieRescuable?: boolean;
  banditEnemy?: boolean;
  banditRescuable?: boolean;
}): CapturableComponent {
  return {
    state: "free",
    remainingTightness: 0,
    totalTightness: 0,
    isStruggling: false,
    isCapturableByTownie: options.townieEnemy ?? false,
    isFreeableByTownie: options.townieRescuable ?? false,
    isCapturableByBandits: options.banditEnemy ?? false,
    isFreeableByBandits: options.banditRescuable ?? false,
  };
}
