import { MapData } from "../map";

export type MapMetadataComponent = {
  sizeX: number;
  sizeY: number;
  roads: Array<{ x: number; y: number }>;
  graph: Array<[string, string]>;
  tileSize: number;
};

export function createMapMetadataComponent(
  map: MapData,
  graph: MapMetadataComponent["graph"],
): MapMetadataComponent {
  return {
    sizeX: map.sizeX,
    sizeY: map.sizeY,
    tileSize: map.tileSize,
    roads: map.roads,
    graph,
  };
}
