import { PIXI } from "../pixi";

export type RendererComponent = {
  isRendering: boolean;
  pixiObject: PIXI.Container;
  anchor: { x: number; y: number };
};

export function createRendererComponent(
  pixiObject: PIXI.Container,
): RendererComponent {
  return { isRendering: false, pixiObject, anchor: { x: 0, y: 0 } };
}

export function createRendererComponentWithAnchor(
  pixiObject: PIXI.Container,
  anchor: { x: number; y: number },
): RendererComponent {
  return { isRendering: false, pixiObject, anchor };
}
