import { AIAllyComponent } from "../components/ai-ally";
import { AIDeliveryComponent } from "../components/ai-delivery";
import { AIEnemyComponent } from "../components/ai-enemy";
import { AIGuardComponent } from "../components/ai-guard";
import { MapCameraPositionComponent } from "../components/camera-position";
import { CapturableComponent } from "../components/capturable";
import { CapturePreventionComponent } from "../components/capture-prevention";
import { CharacterSpriteRenderUpdaterComponent } from "../components/character-sprite-render-updater";
import { ControlsPlayerComponent } from "../components/controls-player";
import { ControlsTitleScreenComponent } from "../components/controls-title-screen";
import { InteractibleNPCComponent } from "../components/interactible-npc";
import { InventoryComponent } from "../components/inventory";
import { MapMetadataComponent } from "../components/map-metadata";
import { CharacterMapMovementComponent as MapMovementComponent } from "../components/map-movement";
import { CharacterMapPathComponent as MapPathingComponent } from "../components/map-pathing";
import { MapPositionComponent } from "../components/map-position";
import { RendererComponent } from "../components/renderer";
import { SpawnerAllyComponent } from "../components/spawner-ally";
import { SpawnerDeliveryComponent } from "../components/spawner-delivery";
import { SpawnerEnemyComponent } from "../components/spawner-enemy";
import { SpawnerGuardComponent } from "../components/spawner-guard";
import { UIPlayerUpdaterComponent } from "../components/ui-player-updater";

export type EntityKind =
  | "player"
  | "ally"
  | "deliveryGiver"
  | "deliveryTarget"
  | "enemy"
  | "house"
  | "camp"
  | "other";

export type EntityType = {
  id: string;
  type: EntityKind;
  deletionFlag?: true;
  aiAlly?: AIAllyComponent;
  aiDelivery?: AIDeliveryComponent;
  aiEnemy?: AIEnemyComponent;
  aiGuard?: AIGuardComponent;
  capturable?: CapturableComponent;
  capturePrevention?: CapturePreventionComponent;
  characterSpriteRenderUpdater?: CharacterSpriteRenderUpdaterComponent;
  controlsPlayer?: ControlsPlayerComponent;
  controlsTitleScreen?: ControlsTitleScreenComponent;
  inventory?: InventoryComponent;
  interactibleNPC?: InteractibleNPCComponent;
  mapCameraPosition?: MapCameraPositionComponent;
  mapMetadata?: MapMetadataComponent;
  mapMovement?: MapMovementComponent;
  mapPathing?: MapPathingComponent;
  mapPosition?: MapPositionComponent;
  mapRenderer?: RendererComponent;
  spawnerAlly?: SpawnerAllyComponent;
  spawnerDelivery?: SpawnerDeliveryComponent;
  spawnerEnemy?: SpawnerEnemyComponent;
  spawnerGuard?: SpawnerGuardComponent;
  uiPlayerUpdater?: UIPlayerUpdaterComponent;
  uiRenderer?: RendererComponent;
};
