import { ControllerSystemMethod } from "../engine";
import { createBanditScene } from "../scene/bandit";
import { createMainScene } from "../scene/main";

export function controllerControlsTitleScreenSystem(): ControllerSystemMethod {
  return (game) => {
    for (const entity of game.gameData.entities) {
      if (!entity.controlsTitleScreen) continue;
      if (game.controls.keys.action1) {
        entity.controlsTitleScreen.isPressed = true;
        continue;
      } else {
        if (entity.controlsTitleScreen.isPressed) {
          entity.deletionFlag = true;
          const url = new URLSearchParams(window.location.search);
          if (url.has("bandit")) createBanditScene(game);
          else createMainScene(game);
        }
      }
    }
  };
}
