import { ControllerSystemMethod } from "../engine";

export function controllerSpriteCharacterInventorySystem(): ControllerSystemMethod {
  return (game) => {
    for (const entity of game.gameData.entities) {
      if (!entity.inventory) continue;
      if (!entity.characterSpriteRenderUpdater) continue;
      entity.characterSpriteRenderUpdater.clothing = entity.inventory.clothes;
      if (entity.inventory.money > 0) {
        entity.characterSpriteRenderUpdater.displayedMoney =
          entity.inventory.money;
      } else {
        entity.characterSpriteRenderUpdater.displayedMoney = undefined;
      }
    }
  };
}
