import { SystemMethod } from "../engine";

export function rendererMapCameraPositionSystem(): SystemMethod {
  return (game) => {
    const map = game.gameData.entities.find((e) => e.mapMetadata);
    if (!map) return;
    if (!map.mapMetadata) return;
    for (const entity of game.gameData.entities) {
      if (!entity.mapCameraPosition) continue;
      if (!entity.mapPosition) continue;
      game.mapContainer.x = Math.max(
        -map.mapMetadata.sizeX * map.mapMetadata.tileSize + 800,
        Math.min(0, -entity.mapPosition.x * map.mapMetadata.tileSize + 400),
      );
      game.mapContainer.y = Math.max(
        -map.mapMetadata.sizeY * map.mapMetadata.tileSize + 600,
        Math.min(0, -entity.mapPosition.y * map.mapMetadata.tileSize + 300),
      );
    }
  };
}
