import { SystemMethod } from "../engine";

export function rendererMapPositionSystem(): SystemMethod {
  return (game) => {
    const map = game.gameData.entities.find((e) => e.mapMetadata);
    if (!map) return;
    if (!map.mapMetadata) return;
    for (const entity of game.gameData.entities) {
      if (!entity.mapPosition) continue;
      if (!entity.mapRenderer) continue;
      entity.mapRenderer.pixiObject.x =
        entity.mapPosition.x * map.mapMetadata.tileSize +
        entity.mapRenderer.anchor.x;
      entity.mapRenderer.pixiObject.y =
        entity.mapPosition.y * map.mapMetadata.tileSize +
        entity.mapRenderer.anchor.y;
      entity.mapRenderer.pixiObject.zIndex = Math.floor(
        entity.mapPosition.y * 10,
      );
    }
  };
}
