import { getRandomIntegerInRange } from "./random";

/**
 * Generate a new UUID
 * @returns {string} A new UUID
 */
export function generateUUID(): string {
  return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function (c) {
    const raw_value = getRandomIntegerInRange(0, 16);
    if (c == "x") return raw_value.toString(16);
    const clean_value = (raw_value & 0x3) | 0x8;
    return clean_value.toString(16);
  });
}
